SETS
i                          '15 highest values' /1*15/
k                          '' /'10%', '8%', '6%', '4%', '2%', '1%'/
*primary sets
TradeDate(*)               'Trading date'
TradePeriod(*)             'Three hour trading period'
Season(*)                  'Rating Season'
MonthID(*)                 'Month ID'
DayID(*)                   'Day ID'
Node(*)                    'Market node'
Offer(*)                   'Offer'
Island                     'Island'
Branch(*)                  'Branch name'
BranchGroupConstraint(*)   'Branch group constraint name'
Scheme(*)                  'Generation scheme'
SequenceID(*)              'Hydro inflow sequence'
SourceID(*)                'Hydro Source'

*two dimension sets
BranchNodeFr(Branch,Node)              'Branch NodeFrom mapping'
BranchNodeTo(Branch,Node)              'Branch NodeTo mapping'
NodeIsland(Node,Island)                'Node Island mapping'
OfferNode(Offer,Node)                  'Offer Node mapping'
SchemeOffer(Scheme,Offer)              'Scheme offer mapping'
SourceScheme(SourceID,Scheme)          'Source scheme mapping'
SourceIsland(SourceID,Island)          'Source island mapping'

*Three dimension sets
*TradeDate_MonthID_DayID_Map(TradeDate,MonthID,DayID)      'TradeDate MonthID and DayID Mapping'
TradeDateMonthID(TradeDate,MonthID)      'TradeDate MonthID and DayID Mapping'
TradeDateDayID(TradeDate,DayID)          'TradeDate MonthID and DayID Mapping'
;

ALIAS (TradeDate,TradeDate1,TradeDate2), (i,i1,i2,i3,i4,i5,i6,i7);

PARAMETERS
BranchCapacity(Branch,Season)                            'Capacity applied for a Branch'
BranchClosedStatus(Branch)                               'Status of a branch'
BranchGroupConstraintLimit(BranchGroupConstraint)        'RHS value of a branch group constraint'
BranchGroupConstraintSense(BranchGroupConstraint)        'Sense of a constraint -1(<=)  0(=)  1(>=)'
SchemeType(Scheme)                           '1 = Profiled output, 2 = Thermal, 3 = TKU and RPO and MAN, 4 = Waikato, 5 = Waitaki and Clutha'

*Data and output for trading period
TradePeriodBranchConstraintLHS(TradeDate,TradePeriod,BranchGroupConstraint)              'LHS valaue of a constraint'
TradePeriodBranchConstraintMarginal(TradeDate,TradePeriod,BranchGroupConstraint)        'Marginal value of a constraint - only posivite if constraint binding'
TradePeriodBranchFixedLoss(TradeDate,TradePeriod,BranchGroupConstraint)                  'Branch fixed loss'
TradePeriodBranchFlow(TradeDate,TradePeriod,Branch)                                 'Branch flow'
TradePeriodBranchLoss(TradeDate,TradePeriod,Branch)                                 'Branch dynamic loss'
TradePeriodBranchMarginal(TradeDate,TradePeriod,Branch)                             'Marginal value of a branch - only posivite if branch flow binding'
TradePeriodNodeDemand(TradeDate,TradePeriod,Node)                                   'GXP demand'
TradePeriodNodePrice(TradeDate,TradePeriod,Node)                                    'Nodal price'
TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)                                'Cleared generation offer'
DailyInflow(DayID,MonthID,SourceID,SequenceID)                                  'Daily inflow - Comit hydro data'

*Calculated Data
Percentile(i)                                                                     'Percentile value for each highest values'

TradeDateInflow(TradeDate,SourceID,SequenceID)                                    'Daily inflow apllied for each trading date'

TokaanuDailyOutput(TradeDate,SequenceID)                                           'Tokaanu output relating to Taupo inflow'
RangipoDailyOutput(TradeDate,SequenceID)                                           'Rangipo output relating to Taupo inflow'
WaikatoDailyOutput(TradeDate)                                                       'Waikato output combined with Tokaanu and Rangipo output'

ManapouriDailyOutput(TradeDate)                                                     'Manapouri output'
WaitakiDailyOutput(TradeDate)                                                       'Waitaki output'
CluthaDailyOutput(TradeDate)                                                        'Clutha output'

NIHydroDailyOutput(TradeDate,SequenceID)                                           'Daily NI storable hydro generation excluding corrected Tokaanu and Rangipo generation output'
SIHydroDailyOutput(TradeDate,SequenceID)                                           'Daily SI storable hydro generation'
NZHydroDailyOutput(TradeDate,SequenceID)                                           'Daily NI + SI storable hydro generation'

NIDailyInflow(TradeDate,SequenceID)                                                'Daily inflow of NI storage - Taupo + addTaupo + Waikato'
SIDailyInflow(TradeDate,SequenceID)                                                'Daily inflow of SI storage - Hawea + Wakapitu + Wanaka + Manapouri + TeAnau + Ohau + Pukaki + Tekapo'
NZDailyInflow(TradeDate,SequenceID)                                                'Daily inflow of NI + SI storage'

NICumulativeStorage(TradeDate,SequenceID)                                          'NI cumulative storage'
SICumulativeStorage(TradeDate,SequenceID)                                          'SI cumulative storage'
NZCumulativeStorage(TradeDate,SequenceID)                                          'NI + SI cumulative storage'

NIMinIntinalStorage(TradeDate,SequenceID)                                          'NI minimum intial storage for each hydro sequence'
SIMinIntinalStorage(TradeDate,SequenceID)                                          'SI minimum intial storage for each hydro sequence'
NZMinIntinalStorage(TradeDate,SequenceID)                                          'NZ minimum intial storage for each hydro sequence'

NIHighestValues(TradeDate,i)                                                        '15 highest values for NI HRC'
SIHighestValues(TradeDate,i)                                                        '15 highest values for SI HRC'
NZHighestValues(TradeDate,i)                                                        '15 highest values for NZ HRC'

NIRiskYValue(TradeDate,k)                                                           'Y values of risk curves'
SIRiskYValue(TradeDate,k)                                                           'Y values of risk curves'
NZRiskYValue(TradeDate,k)                                                           'Y values of risk curves'

RiskXValue(k)                                                                        'X values of risk curves'
Slope(TradeDate)                                                                     'Slope Value of function y = ln(x) + b'
Intercept(TradeDate)                                                                 'Slope Value of function y = ln(x) + b'
logPctTest(i)                                                                        ''

OTADailyOutput(TradeDate)                                                            'Otahuhu output'
TCCDailyOutput(TradeDate)                                                            'TCC output'
HLYDailyOutput(TradeDate)                                                            'Huntly 1-4 output'
E3PDailyOutput(TradeDate)                                                            'Huntly 5 output'
P40DailyOutput(TradeDate)                                                           'Huntly 6 output'
SWNDailyOutput(TradeDate)                                                            'Southdown output'
WHIDailyOutput(TradeDate)                                                            'Whiniraki output'
;

SCALAR iteration      'iteration count'   /1/;

*Loading data from gdx files
$GDXIN 'Outputs\Output_All'
$LOAD TradeDate TradePeriod DayID MonthID Season
$LOAD TradeDateMonthID TradeDateDayID
$LOAD Node Offer Island Branch BranchGroupConstraint Scheme
$LOAD BranchNodeFr BranchNodeTo NodeIsland OfferNode SchemeOffer
$LOAD BranchCapacity BranchClosedStatus BranchGroupConstraintLimit BranchGroupConstraintSense SchemeType
$LOAD TradePeriodBranchConstraintLHS TradePeriodBranchConstraintMarginal
$LOAD TradePeriodBranchFixedLoss TradePeriodBranchFlow TradePeriodBranchLoss
$LOAD TradePeriodBranchMarginal TradePeriodNodeDemand TradePeriodNodePrice TradePeriodOfferCleared
$GDXIN

$GDXIN 'Inputs\Hydro_Inflows_Spectra'
$LOAD SequenceID SourceID
$LOAD SourceScheme SourceIsland
$LOAD DailyInflow
$GDXIN

TradeDateInflow(TradeDate,SourceID,SequenceID) = Sum[(DayID,MonthID) $ [TradeDateMonthID(TradeDate,MonthID) and TradeDateDayID(TradeDate,DayID)],DailyInflow(DayID,MonthID,SourceID,SequenceID)];
TradeDateInflow(TradeDate,SourceID,SequenceID) $ [TradeDateMonthID(TradeDate,'2') and TradeDateDayID(TradeDate,'29')] = DailyInflow('28','2',SourceID,SequenceID);

Percentile(i) = ord(i) / card(SequenceID);
RiskXValue('10%') = 0.1;
RiskXValue('8%') = 0.08;
RiskXValue('6%') = 0.06;
RiskXValue('4%') = 0.04;
RiskXValue('2%') = 0.02;
RiskXValue('1%') = 0.01;

*************************************Calculating NI HRC*******************************************************************************************************************************************************
*NI hydro generation output
NIHydroDailyOutput(TradeDate,SequenceID) = 0
+ Sum[(TradePeriod,Offer) $ [SchemeOffer('Tokaanu',Offer) or SchemeOffer('Rangipo',Offer) or SchemeOffer('Waikato',Offer)
                          or SchemeOffer('Matahina',Offer) or SchemeOffer('Waikaremoana',Offer) or SchemeOffer('Mangahao',Offer)
                          or SchemeOffer('Wheao',Offer) or SchemeOffer('Mangaio',Offer) or SchemeOffer('Waipa',Offer)
                            ], TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];

*NI storable inflow
NIDailyInflow(TradeDate,SequenceID) =  Sum[SourceID $ SourceIsland(SourceID,'NI'), TradeDateInflow(TradeDate,SourceID,SequenceID)];

*NI cumulative storage
NICumulativeStorage(TradeDate,SequenceID) =  Sum[TradeDate1 $ [ord(TradeDate1) <= ord(TradeDate)], NIDailyInflow(TradeDate1,SequenceID) - NIHydroDailyOutput(TradeDate1,SequenceID)];

*NI minimum initial storage
NIMinIntinalStorage(TradeDate,SequenceID) $ [ord(TradeDate) = 1] =
- Smin[TradeDate1 $ [(ord(TradeDate1) >= ord(TradeDate)) and (ord(TradeDate1) < ord(TradeDate)+365)], NICumulativeStorage(TradeDate1,SequenceID)];

NIMinIntinalStorage(TradeDate,SequenceID) $ [ord(TradeDate) > 1] = Sum[TradeDate2 $ [ord(TradeDate2) = ord(TradeDate)-1],NICumulativeStorage(TradeDate2,SequenceID)]
- Smin[TradeDate1 $ [(ord(TradeDate1) >= ord(TradeDate)) and (ord(TradeDate1) < ord(TradeDate)+365)], NICumulativeStorage(TradeDate1,SequenceID)];

*15 highest values for NI HRC
NIHighestValues(TradeDate,'1') = Smax[SequenceID,NIMinIntinalStorage(TradeDate,SequenceID)]
For(iteration = 2 to 15,
   NIHighestValues(TradeDate,i) $ [ord(i) = iteration] = Smax[SequenceID $ [NIMinIntinalStorage(TradeDate,SequenceID) < Sum[i2 $ [ord(i2) = ord(i)-1], NIHighestValues(TradeDate,i2)]], NIMinIntinalStorage(TradeDate,SequenceID)];
);

*Calculate NI log function of the form y=a*ln(x) + b ---> HRC risk curve values
Slope(TradeDate) = {card(i)*Sum[i,log(Percentile(i))*NIHighestValues(TradeDate,i)] - Sum[i2,log(Percentile(i2))]*Sum[i3,NIHighestValues(TradeDate,i3)]} / {card(i4)*Sum[i5,log(Percentile(i5))*log(Percentile(i5))] - Sum[i6,log(Percentile(i6))]*Sum[i7,log(Percentile(i7))]};

Intercept(TradeDate) = {Sum[i,NIHighestValues(TradeDate,i)] - Slope(TradeDate)*Sum[i2,log(Percentile(i2))]} / card(i3);

NIRiskYValue(TradeDate,k) = Slope(TradeDate) * log(RiskXValue(k)) + Intercept(TradeDate);

NIMinIntinalStorage(TradeDate,SequenceID) $ [NIMinIntinalStorage(TradeDate,SequenceID) <= 0] = 0.01;

****************************************************************************************************************************************************************************************




*************************************Calculating SI HRC*********************************************************************************************************************************

*SI hydro generation output
SIHydroDailyOutput(TradeDate,SequenceID) = 0
+ Sum[(TradePeriod,Offer) $ [SchemeOffer('Manapouri',Offer) or SchemeOffer('Waitaki',Offer)
                          or SchemeOffer('Clutha',Offer) or SchemeOffer('Cobb',Offer)
                          or SchemeOffer('Coleridge',Offer) or SchemeOffer('Argyle',Offer)
                            ], TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];

*SI storable inflow
SIDailyInflow(TradeDate,SequenceID) =  Sum[SourceID $ SourceIsland(SourceID,'SI'), TradeDateInflow(TradeDate,SourceID,SequenceID)]
;

*SI cumulative storage
SICumulativeStorage(TradeDate,SequenceID) =  Sum[TradeDate1 $ [ord(TradeDate1) <= ord(TradeDate)], SIDailyInflow(TradeDate1,SequenceID) - SIHydroDailyOutput(TradeDate1,SequenceID)];

*SI minimum initial storage
SIMinIntinalStorage(TradeDate,SequenceID) $ [ord(TradeDate) = 1] =
- Smin[TradeDate1 $ [(ord(TradeDate1) >= ord(TradeDate)) and (ord(TradeDate1) < ord(TradeDate)+365)], SICumulativeStorage(TradeDate1,SequenceID)];

SIMinIntinalStorage(TradeDate,SequenceID) $ [ord(TradeDate) > 1] = Sum[TradeDate2 $ [ord(TradeDate2) = ord(TradeDate)-1],SICumulativeStorage(TradeDate2,SequenceID)]
- Smin[TradeDate1 $ [(ord(TradeDate1) >= ord(TradeDate)) and (ord(TradeDate1) < ord(TradeDate)+365)], SICumulativeStorage(TradeDate1,SequenceID)];

*15 highest values for SI HRC
SIHighestValues(TradeDate,'1') = Smax[SequenceID,SIMinIntinalStorage(TradeDate,SequenceID)]
For(iteration = 2 to 15,
   SIHighestValues(TradeDate,i) $ [ord(i) = iteration] = Smax[SequenceID $ [SIMinIntinalStorage(TradeDate,SequenceID) < Sum[i2 $ [ord(i2) = ord(i)-1], SIHighestValues(TradeDate,i2)]], SIMinIntinalStorage(TradeDate,SequenceID)];
);


*Calculate SI log function of the form y=a*ln(x) + b ---> HRC risk curve values
option clear = Slope;
option clear = Intercept;

Slope(TradeDate) = {card(i)*Sum[i,log(Percentile(i))*SIHighestValues(TradeDate,i)] - Sum[i2,log(Percentile(i2))]*Sum[i3,SIHighestValues(TradeDate,i3)]} / {card(i4)*Sum[i5,log(Percentile(i5))*log(Percentile(i5))] - Sum[i6,log(Percentile(i6))]*Sum[i7,log(Percentile(i7))]};

Intercept(TradeDate) = {Sum[i,SIHighestValues(TradeDate,i)] - Slope(TradeDate)*Sum[i2,log(Percentile(i2))]} / card(i3);

SIRiskYValue(TradeDate,k) = Slope(TradeDate) * log(RiskXValue(k)) + Intercept(TradeDate);

****************************************************************************************************************************************************************************************




*************************************Calculating NZ HRC*********************************************************************************************************************************

*NZ minimum initial storage
NZMinIntinalStorage(TradeDate,SequenceID) = NIMinIntinalStorage(TradeDate,SequenceID) + SIMinIntinalStorage(TradeDate,SequenceID);

*15 highest values for NZ HRC
NZHighestValues(TradeDate,'1') = Smax[SequenceID,NZMinIntinalStorage(TradeDate,SequenceID)]
For(iteration = 2 to 15,
   NZHighestValues(TradeDate,i) $ [ord(i) = iteration] = Smax[SequenceID $ [NZMinIntinalStorage(TradeDate,SequenceID) < Sum[i2 $ [ord(i2) = ord(i)-1], NZHighestValues(TradeDate,i2)]], NZMinIntinalStorage(TradeDate,SequenceID)];
);


*Calculate NZ log function of the form y=a*ln(x) + b ---> HRC risk curve values
option clear = Slope;
option clear = Intercept;

Slope(TradeDate) = {card(i)*Sum[i,log(Percentile(i))*NZHighestValues(TradeDate,i)] - Sum[i2,log(Percentile(i2))]*Sum[i3,NZHighestValues(TradeDate,i3)]} / {card(i4)*Sum[i5,log(Percentile(i5))*log(Percentile(i5))] - Sum[i6,log(Percentile(i6))]*Sum[i7,log(Percentile(i7))]};

Intercept(TradeDate) = {Sum[i,NZHighestValues(TradeDate,i)] - Slope(TradeDate)*Sum[i2,log(Percentile(i2))]} / card(i3);

NZRiskYValue(TradeDate,k) = Slope(TradeDate) * log(RiskXValue(k)) + Intercept(TradeDate);

****************************************************************************************************************************************************************************************
SIRiskYValue(TradeDate,k) $ [SIRiskYValue(TradeDate,k) <= 0] = 0.01;
NZRiskYValue(TradeDate,k) $ [NZRiskYValue(TradeDate,k) <= 0] = 0.01;

SIMinIntinalStorage(TradeDate,SequenceID) $ [SIMinIntinalStorage(TradeDate,SequenceID) <= 0] = 0.01;
NZMinIntinalStorage(TradeDate,SequenceID) $ [NZMinIntinalStorage(TradeDate,SequenceID) <= 0] = 0.01;


*************************************Calculating Thermal Outputs*************************************************************************************************************************

OTADailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Otahuhu B',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
TCCDailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('TCC',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
HLYDailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Huntly (units 1-4)',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
E3PDailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Huntly U5 (e3p)',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
P40DailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Huntly U6 (P40)',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
SWNDailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Southdown',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
WHIDailyOutput(TradeDate) = Sum[(TradePeriod,Offer) $ SchemeOffer('Whirinaki',Offer), TradePeriodOfferCleared(TradeDate,TradePeriod,Offer)*3/1000];
****************************************************************************************************************************************************************************************


Execute_unload  'Outputs\HSS_Results', TradeDate, SequenceID, NIDailyInflow, SIDailyInflow
                                                       NIHydroDailyOutput, SIHydroDailyOutput
                                                       NICumulativeStorage, SICumulativeStorage
                                                       NIMinIntinalStorage, SIMinIntinalStorage, NZMinIntinalStorage
                                                       NIHighestValues, SIHighestValues, NZHighestValues
                                                       NIRiskYValue, SIRiskYValue, NZRiskYValue
                                                       OTADailyOutput, TCCDailyOutput, HLYDailyOutput
                                                       E3PDailyOutput, P40DailyOutput, SWNDailyOutput, WHIDailyOutput;

FILES
SI_HRC /'Outputs\SI_HRC_Results.csv'/
NZ_HRC /'Outputs\NZ_HRC_Results.csv'/
;
SI_HRC.pc = 5;                    SI_HRC.lw = 0;                   SI_HRC.pw = 9999;
NZ_HRC.pc = 5;                    NZ_HRC.lw = 0;                   NZ_HRC.pw = 9999;

put SI_HRC;
put '', '1%', '2%', '4%', '6%', '8%', '10%' /;

put SI_HRC;
loop(TradeDate $ TradeDateDayID(TradeDate,'1'),
   put TradeDate.tl, SIRiskYValue(TradeDate,'1%'), SIRiskYValue(TradeDate,'2%'), SIRiskYValue(TradeDate,'4%');
   put SIRiskYValue(TradeDate,'6%'), SIRiskYValue(TradeDate,'8%'), SIRiskYValue(TradeDate,'10%') /;
);
loop(TradeDate $ [ord(TradeDate)=card(TradeDate)],
   put TradeDate.tl, SIRiskYValue(TradeDate,'1%'), SIRiskYValue(TradeDate,'2%'), SIRiskYValue(TradeDate,'4%');
   put SIRiskYValue(TradeDate,'6%'), SIRiskYValue(TradeDate,'8%'), SIRiskYValue(TradeDate,'10%') /;
);

put NZ_HRC;
put '', '1%', '2%', '4%', '6%', '8%', '10%' /;

put NZ_HRC;
loop(TradeDate $ TradeDateDayID(TradeDate,'1'),
   put TradeDate.tl, NZRiskYValue(TradeDate,'1%'), NZRiskYValue(TradeDate,'2%'), NZRiskYValue(TradeDate,'4%');
   put NZRiskYValue(TradeDate,'6%'), NZRiskYValue(TradeDate,'8%'), NZRiskYValue(TradeDate,'10%') /;
);
loop(TradeDate $ [ord(TradeDate)=card(TradeDate)],
   put TradeDate.tl, NZRiskYValue(TradeDate,'1%'), NZRiskYValue(TradeDate,'2%'), NZRiskYValue(TradeDate,'4%');
   put NZRiskYValue(TradeDate,'6%'), NZRiskYValue(TradeDate,'8%'), NZRiskYValue(TradeDate,'10%') /;
);

File Done /"Done.txt"/;
Put Done;
Put "Done";