$Include ModelDate.put

PARAMETERS
*Output Data
oTradePeriodOfferCleared(TradeDate,TradePeriod,Offer)    'Output offer cleared by trading period'
oTradePeriodNodePrice(TradeDate,TradePeriod,Node)        'Output node marginal price'
oTradePeriodBranchFlow(TradeDate,TradePeriod,Branch)     'Output branch flow'
oTradePeriodBranchMarginal(TradeDate,TradePeriod,Branch) 'Output branch marginal price'
oTradePeriodBranchLoss(TradeDate,TradePeriod,Branch)     'Output branch loss'
oTradePeriodBranchFixedLoss(TradeDate,TradePeriod,Branch)'Output branch loss'

oTradePeriodBranchConstraintLHS(TradeDate,TradePeriod,BranchGroupConstraint)                'Output branch constraint LHS value'
oTradePeriodBranchConstraintMarginal(TradeDate,TradePeriod,BranchGroupConstraint)           'Output branch constraint marginal value'
;

$GDXIN Inputs\HSS_Data.gdx
$LOAD TradePeriod Season
$LOAD TradePeriodSeason
$LOAD Island Node Branch FlowDirection LossSegment BranchGroupConstraint
$LOAD RefNode ACBranch DCBranch
$LOAD DCDirection
$LOAD NodeIsland BranchNodeFr BranchNodeTo
$LOAD BranchCapacity BranchSusceptance BranchResistance BranchFixedLoss
$LOAD BranchNumLossTranches BranchOpenStatus BranchClosedStatus
$LOAD ValidLossSegment ACBranchLossMW ACBranchLossFactor
$LOAD HVDCBreakPointMWLoss HVDCBreakPointMWFlow
$LOAD BranchGroupConstraintFactor BranchGroupConstraintSense BranchGroupConstraintLimit
$LOAD Offer Scheme TradeBlock
$LOAD OfferNode SchemeOffer
$LOAD TradePeriodOfferMW TradePeriodOfferPrice
$LOAD TradePeriodNodeDemand
$GDXIN

Solve VSPD_HRC using lp minimizing NETCOST;

oTradePeriodOfferCleared(TradeDate,TradePeriod,Offer) = GENERATION.l(TradeDate,TradePeriod,Offer);
oTradePeriodNodePrice(TradeDate,TradePeriod,Node) = -ACNodeNetInjectionDefinition2.m(TradeDate,TradePeriod,Node);

oTradePeriodBranchFlow(TradeDate,TradePeriod,ACBranch) = ACBRANCHFLOW.l(TradeDate,TradePeriod,ACBranch);
oTradePeriodBranchFlow(TradeDate,TradePeriod,DCBranch) = HVDCLINKFLOW.l(TradeDate,TradePeriod,DCBranch);

oTradePeriodBranchMarginal(TradeDate,TradePeriod,ACBranch) = -Sum(FlowDirection, ACBranchMaximumFlow.m(TradeDate,TradePeriod,ACBranch,FlowDirection)) $ UseACBranchLimits;
oTradePeriodBranchMarginal(TradeDate,TradePeriod,DCBranch) = -HVDCLinkMaximumFlow.m(TradeDate,TradePeriod,DCBranch) $ UseHVDCLinkLimits;

oTradePeriodBranchLoss(TradeDate,TradePeriod,ACBranch) = Sum(FlowDirection,ACBRANCHLOSSESDIRECTED.l(TradeDate,TradePeriod,ACBranch,FlowDirection));
oTradePeriodBranchLoss(TradeDate,TradePeriod,DCBranch) = HVDCLINKLOSSES.l(TradeDate,TradePeriod,DCBranch);

oTradePeriodBranchFixedLoss(TradeDate,TradePeriod,Branch) = BranchFixedLoss(Branch);

oTradePeriodBranchConstraintLHS(TradeDate,TradePeriod,BranchGroupConstraint) = BranchSecurityConstraintLE.l(TradeDate,TradePeriod,BranchGroupConstraint);
oTradePeriodBranchConstraintMarginal(TradeDate,TradePeriod,BranchGroupConstraint) = BranchSecurityConstraintLE.m(TradeDate,TradePeriod,BranchGroupConstraint);

execute_unload 'Output', oTradePeriodOfferCleared, oTradePeriodNodePrice
oTradePeriodBranchFlow, oTradePeriodBranchMarginal
oTradePeriodBranchLoss, oTradePeriodBranchFixedLoss
oTradePeriodBranchConstraintLHS, oTradePeriodBranchConstraintMarginal;
